diff --git a/drivers/soc/imx/gpcv2.c b/drivers/soc/imx/gpcv2.c
index 7a47d14fde445..8d27a227ba02d 100644
--- a/drivers/soc/imx/gpcv2.c
+++ b/drivers/soc/imx/gpcv2.c
@@ -298,6 +298,8 @@ struct imx_pgc_domain {
 
 	unsigned int pgc_sw_pup_reg;
 	unsigned int pgc_sw_pdn_reg;
+
+	int enabled;
 };
 
 struct imx_pgc_domain_data {
@@ -313,6 +315,52 @@ to_imx_pgc_domain(struct generic_pm_domain *genpd)
 	return container_of(genpd, struct imx_pgc_domain, genpd);
 }
 
+static int imx_pgc_power_pre_up(struct generic_pm_domain *genpd)
+{
+	struct imx_pgc_domain *domain = to_imx_pgc_domain(genpd);
+	int ret;
+
+	ret = clk_bulk_prepare(domain->num_clks, domain->clks);
+	if (ret)
+		dev_err(domain->dev, "failed to prepare reset clocks\n");
+
+	return ret;
+}
+
+static int imx_pgc_power_post_up(struct generic_pm_domain *genpd)
+{
+	struct imx_pgc_domain *domain = to_imx_pgc_domain(genpd);
+
+	if (!domain->keep_clocks && domain->enabled)
+		clk_bulk_unprepare(domain->num_clks, domain->clks);
+
+	return 0;
+}
+
+static int imx_pgc_power_down_pre(struct generic_pm_domain *genpd)
+{
+	struct imx_pgc_domain *domain = to_imx_pgc_domain(genpd);
+	int ret;
+
+	if (!domain->keep_clocks || !domain->enabled) {
+		ret = clk_bulk_prepare(domain->num_clks, domain->clks);
+		if (ret)
+			dev_err(domain->dev, "failed to prepare reset clocks\n");
+	}
+
+	return ret;
+}
+
+static int imx_pgc_power_down_post(struct generic_pm_domain *genpd)
+{
+	struct imx_pgc_domain *domain = to_imx_pgc_domain(genpd);
+
+	if (!domain->keep_clocks || !domain->enabled)
+		clk_bulk_unprepare(domain->num_clks, domain->clks);
+
+	return 0;
+}
+
 static int imx_pgc_power_up(struct generic_pm_domain *genpd)
 {
 	struct imx_pgc_domain *domain = to_imx_pgc_domain(genpd);
@@ -338,7 +386,7 @@ static int imx_pgc_power_up(struct generic_pm_domain *genpd)
 	reset_control_assert(domain->reset);
 
 	/* Enable reset clocks for all devices in the domain */
-	ret = clk_bulk_prepare_enable(domain->num_clks, domain->clks);
+	ret = clk_bulk_enable(domain->num_clks, domain->clks);
 	if (ret) {
 		dev_err(domain->dev, "failed to enable reset clocks\n");
 		goto out_regulator_disable;
@@ -397,12 +445,14 @@ static int imx_pgc_power_up(struct generic_pm_domain *genpd)
 
 	/* Disable reset clocks for all devices in the domain */
 	if (!domain->keep_clocks)
-		clk_bulk_disable_unprepare(domain->num_clks, domain->clks);
+		clk_bulk_disable(domain->num_clks, domain->clks);
+
+	domain->enabled++;
 
 	return 0;
 
 out_clk_disable:
-	clk_bulk_disable_unprepare(domain->num_clks, domain->clks);
+	clk_bulk_disable(domain->num_clks, domain->clks);
 out_regulator_disable:
 	if (!IS_ERR(domain->regulator))
 		regulator_disable(domain->regulator);
@@ -420,7 +470,7 @@ static int imx_pgc_power_down(struct generic_pm_domain *genpd)
 
 	/* Enable reset clocks for all devices in the domain */
 	if (!domain->keep_clocks) {
-		ret = clk_bulk_prepare_enable(domain->num_clks, domain->clks);
+		ret = clk_bulk_enable(domain->num_clks, domain->clks);
 		if (ret) {
 			dev_err(domain->dev, "failed to enable reset clocks\n");
 			return ret;
@@ -467,7 +517,7 @@ static int imx_pgc_power_down(struct generic_pm_domain *genpd)
 	}
 
 	/* Disable reset clocks for all devices in the domain */
-	clk_bulk_disable_unprepare(domain->num_clks, domain->clks);
+	clk_bulk_disable(domain->num_clks, domain->clks);
 
 	if (!IS_ERR(domain->regulator)) {
 		ret = regulator_disable(domain->regulator);
@@ -479,13 +529,17 @@ static int imx_pgc_power_down(struct generic_pm_domain *genpd)
 		}
 	}
 
+	domain->enabled--;
+
 	pm_runtime_put_sync_suspend(domain->dev);
 
 	return 0;
 
 out_clk_disable:
 	if (!domain->keep_clocks)
-		clk_bulk_disable_unprepare(domain->num_clks, domain->clks);
+		clk_bulk_disable(domain->num_clks, domain->clks);
+
+	domain->enabled--;
 
 	return ret;
 }
@@ -1514,8 +1568,12 @@ static int imx_gpcv2_probe(struct platform_device *pdev)
 		domain->regmap = regmap;
 		domain->regs = domain_data->pgc_regs;
 
-		domain->genpd.power_on  = imx_pgc_power_up;
-		domain->genpd.power_off = imx_pgc_power_down;
+		domain->genpd.power_pre_on	= imx_pgc_power_pre_up;
+		domain->genpd.power_on		= imx_pgc_power_up;
+		domain->genpd.power_post_on	= imx_pgc_power_post_up;
+		domain->genpd.power_off_pre	= imx_pgc_power_down_pre;
+		domain->genpd.power_off		= imx_pgc_power_down;
+		domain->genpd.power_off_post	= imx_pgc_power_down_post;
 
 		pd_pdev->dev.parent = dev;
 		pd_pdev->dev.of_node = np;